//+------------------------------------------------------------------+
//|                                                    ADX color.mq4 |
//|                                                            Gyfto |
//|                                        " " |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue
extern int periodADX=14;
extern double focus=0.4;
//     ,   .   -  .
extern double Staturation=1.0;// 
extern double Lightness=0.5;// 
extern bool arrows=false;
extern int CountBars = 350;
extern bool alert=false;
double delta;
double ArrayAbove[];
double ArrayBelow[];
bool above = true;
bool below = true;
double PDI1;
double PDI0;
double NDI1;
double NDI0;
int alerts;
int time;

int init()
  {
   focus=MathAbs(focus); if (focus<0.1) focus=0.1; if (focus>10) focus=10;//   (  )     
   for(int i=Bars-1; i>=0; i--) ColorDash(i);//       
   IndicatorBuffers(2);
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, 217);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1, 218);
   SetIndexBuffer(0, ArrayAbove);
   SetIndexBuffer(1, ArrayBelow);
   time=Minute();
   return(0);
  }

int deinit()
  {
   ObjectsDeleteAll(0, OBJ_TREND);//       OBJ_TREND
   Comment(" ");//      
   return(0);
  }

int start()
  {
   if (CountBars >= Bars) CountBars = Bars;
   SetIndexDrawBegin(0, Bars - CountBars);
   SetIndexDrawBegin(1, Bars - CountBars);
   int counted_bars = IndicatorCounted();
   if (counted_bars < 0) return (-1);
   if (counted_bars < 1) for (int i = 1; i <= CountBars; i++) {ArrayAbove[CountBars - i] = 0.0; ArrayBelow[CountBars - i] = 0.0;}
   if (alerts!=IndicatorCounted()){
      alerts=IndicatorCounted();
      above=true; below=true;
   }
   for (i = CountBars; i >= 0; i--){
      PDI1 = iADX(NULL, 0, periodADX, PRICE_CLOSE, MODE_PLUSDI, i + 1);
      PDI0 = iADX(NULL, 0, periodADX, PRICE_CLOSE, MODE_PLUSDI, i);
      NDI1 = iADX(NULL, 0, periodADX, PRICE_CLOSE, MODE_MINUSDI, i + 1);
      NDI0 = iADX(NULL, 0, periodADX, PRICE_CLOSE, MODE_MINUSDI, i);
      if (PDI1 < NDI1 && PDI0 > NDI0 && arrows) ArrayAbove[i] = Low[i] - 5.0 * Point;
      if (PDI1 < NDI1 && PDI0 > NDI0 && i==0 && above && alert){
         Alert("    ");
         above=False;
      }
      if (PDI1 > NDI1 && PDI0 < NDI0 && arrows) ArrayBelow[i] = High[i] + 5.0 * Point;
      if (PDI1 > NDI1 && PDI0 < NDI0 && i==0 && below && alert){
         Alert("     ");
         below=False;
      }
   }
   ObjectDelete(StringConcatenate("DashADX",Time[0]));
   ColorDash(0);
   double pM=High[0]-High[1]; string s_pM=StringConcatenate(" pM=", DoubleToStr(pM,8));//   ADX
   double mM=Low[1]-Low[0]; string s_mM=StringConcatenate("\n mM=", DoubleToStr(mM,8));
   double pDM=0; if((pM>mM)&&(pM>0)) pDM=pM; string s_pDM=StringConcatenate("\n pDM=", DoubleToStr(pDM,8));
   double mDM=0; if((mM>pM)&&(mM>0)) mDM=mM; string s_mDM=StringConcatenate("\n mDM=", DoubleToStr(mDM,8));
   double num1=High[0]-Low[0];
   double num2=MathAbs(High[0]-Close[1]);
   double num3=MathAbs(Low[0]-Close[1]);
   double TR=MathMax(MathMax(num1,num2),num3); string s_TR=StringConcatenate("\n TR=", DoubleToStr(TR,8));
   if (TR==0) {double pSDI=0; double mSDI=0;} else {pSDI=100.0*pDM/TR; mSDI=100.0*mDM/TR;}
   string s_pSDI=StringConcatenate("\n pSDI=", DoubleToStr(pSDI,8)); string s_mSDI=StringConcatenate("\n mSDI=", DoubleToStr(mSDI,8));
   string s_delta=StringConcatenate("\n delta=", DoubleToStr(delta,8));
	Comment(s_pM, s_mM, s_pDM, s_mDM, s_TR, s_pSDI, s_mSDI, s_delta);//    
   //: ,       :
   if (time!=Minute() && ObjectGet(StringConcatenate("DashADX ", TimeToStr(Time[1], TIME_DATE|TIME_MINUTES)), OBJPROP_PRICE1)!=Close[1]){
      ObjectSet(StringConcatenate("DashADX ", TimeToStr(Time[1], TIME_DATE|TIME_MINUTES)), OBJPROP_PRICE1, Close[1]);
      time=Minute();
   }
   return(0);
  }

void ColorDash(int index){//  - .     (void)
	delta = iADX(NULL, 0, periodADX, PRICE_CLOSE, MODE_PLUSDI, index) - iADX(NULL, 0, periodADX, PRICE_CLOSE, MODE_MINUSDI, index);//  +DI  -DI
	//NB!     0  100, ..     -100 (0  100)  +100 (100  0)
	delta/=100;//   +100...-100   ... +1.0...-1.0.
	double Hue=SpectralFilter(delta, focus);
	color RGB = HSLtoRGB(Hue, Staturation, Lightness);//   HSL    RGB
	string name=StringConcatenate("dashADX ", TimeToStr(Time[index], TIME_DATE|TIME_MINUTES));//  
	if(index==0){ ObjectCreate(name, OBJ_TREND, 0, Time[0], Bid, Time[1], Close[1]);// OBJ_TREND     
	}else{ ObjectCreate(name, OBJ_TREND, 0, Time[index], Close[index], Time[index+1], Close[index+1]);}//.   .
	ObjectSet(name, OBJPROP_COLOR, RGB);//   OBJ_TREND     +DI  -DI
	ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);//    :    (   )
	ObjectSet(name, OBJPROP_WIDTH, 2);//    2  (    )
	ObjectSet(name, OBJPROP_RAY, false);//      ,  
}

double Hue_To_RGB(double P,double Q,double Tc){//    Integer
	if(Tc<0) Tc+=1.0;
	if(Tc>1.0) Tc-=1.0;
	if(Tc<1.0/6.0) return(P+(Q-P)*6.0*Tc);
	if(Tc<1.0/2.0) return(Q);
	if(Tc<2.0/3.0) return(P+(Q-P)*((2.0/3.0)-Tc)*6.0);
	return(P);
}

color HSLtoRGB(double aH,double aS,double aL){
	if(aS==0){
		double oR=aL*255;
		double oG=aL*255;
		double oB=aL*255;
	}else{
		double Q;
		if(aL<0.5) Q=aL*(1.0+aS); else Q=(aL+aS)-(aS*aL);
		double P=2.0*aL-Q;
		oR=255.0*Hue_To_RGB(P,Q,aH+(1.0/3.0));
		oG=255.0*Hue_To_RGB(P,Q,aH);
		oB=255.0*Hue_To_RGB(P,Q,aH-(1.0/3.0));
	}
	return(0x100*0x100*DoubleToInt(oB)+0x100*DoubleToInt(oG)+DoubleToInt(oR));
}

int DoubleToInt(double var){return(var);}

double SpectralFilter(double var, double focus){
   if (var<0) var=0.5*(MathPow((1-MathPow(MathAbs(var),focus)),1/focus));
   else var=1-0.5*(MathPow((1-MathPow(MathAbs(var),focus)),1/focus));
   return(var);
}