//+------------------------------------------------------------------+
//|                                                    RSI color.mq4 |
//|                                                            Gyfto |
//|                                        " " |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue
extern int periodRSI=14;
extern double focus=1.8;
//     ,   .   -  .
extern double Staturation=1.0;// 
extern double Lightness=0.5;// 
int time;

int init()
  {
   focus=MathAbs(focus); if (focus<0.1) focus=0.1; if (focus>10) focus=10;//   (  )     
   for(int i=Bars-1; i>0; i--) ColorDash(i);//       
   time=Minute();
   return(0);
  }

int deinit()
  {
   ObjectsDeleteAll(0, OBJ_TREND);//       OBJ_TREND
   return(0);
  }

int start()
  {
   ObjectDelete(StringConcatenate("DashRSI ", TimeToStr(Time[0], TIME_DATE|TIME_MINUTES)));
   ColorDash(0);
   //: ,       :
   if (time!=Minute() && ObjectGet(StringConcatenate("DashRSI ", TimeToStr(Time[1], TIME_DATE|TIME_MINUTES)), OBJPROP_PRICE1)!=Close[1]){
      ObjectSet(StringConcatenate("DashRSI ", TimeToStr(Time[1], TIME_DATE|TIME_MINUTES)), OBJPROP_PRICE1, Close[1]);
      time=Minute();
   }
      return(0);
  }

void ColorDash(int index){//   
	double variable = iRSI(NULL, 0, periodRSI, PRICE_CLOSE, index);
	variable/=100;//   RSI 0...100   ... 0...1.
	double Hue=SpectralFilter(variable,focus);//    
	color RGB = HSLtoRGB(Hue, Staturation, Lightness);//   HSL    RGB
	string name=StringConcatenate("dashRSI ", TimeToStr(Time[index], TIME_DATE|TIME_MINUTES));//  
	if(index==0){ ObjectCreate(name, OBJ_TREND, 0, Time[0], Bid, Time[1], Close[1]);// OBJ_TREND     
	}else{ ObjectCreate(name, OBJ_TREND, 0, Time[index], Close[index], Time[index+1], Close[index+1]);}//.   .
	ObjectSet(name, OBJPROP_COLOR, RGB);//   OBJ_TREND     RSI
	ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);//    :    (   )
	ObjectSet(name, OBJPROP_WIDTH, 2);//    2  (    )
	ObjectSet(name, OBJPROP_RAY, false);//      ,  
}

double Hue_To_RGB(double P,double Q,double Tc){//    Integer
	if(Tc<0) Tc+=1.0;
	if(Tc>1.0) Tc-=1.0;
	if(Tc<1.0/6.0) return(P+(Q-P)*6.0*Tc);
	if(Tc<1.0/2.0) return(Q);
	if(Tc<2.0/3.0) return(P+(Q-P)*((2.0/3.0)-Tc)*6.0);
	return(P);
}

color HSLtoRGB(double aH,double aS,double aL){
	if(aS==0){
		double oR=aL*255;
		double oG=aL*255;
		double oB=aL*255;
	}else{
		double Q;
		if(aL<0.5) Q=aL*(1.0+aS); else Q=(aL+aS)-(aS*aL);
		double P=2.0*aL-Q;
		oR=255.0*Hue_To_RGB(P,Q,aH+(1.0/3.0));
		oG=255.0*Hue_To_RGB(P,Q,aH);
		oB=255.0*Hue_To_RGB(P,Q,aH-(1.0/3.0));
	}
	return(0x100*0x100*DoubleToInt(oB)+0x100*DoubleToInt(oG)+DoubleToInt(oR));
}
int DoubleToInt(double var){return(var);}

double SpectralFilter(double var, double focus){
   if (var<0.5) var=MathPow((MathPow(0.5,focus)-MathPow(MathAbs(var-0.5),focus)),1/focus);
   else var=1-MathPow((MathPow(0.5,focus)-MathPow(MathAbs(var-0.5),focus)),1/focus);
   return(var);
}