//+------------------------------------------------------------------+
//|                                                  .mq4 |
//|                                                            Gyfto |
//|                                        " " |
//+------------------------------------------------------------------+
#property indicator_chart_window
extern string    s1="  ";
extern double    Staturation=1.0;
extern double    Lightness=0.5;
extern double    focus=1.0;
extern string    s2="  ";
extern double    Staturation_0=1.0;
extern double    Lightness_0=0.5;
extern string    s3="     ";
extern int       h=60;
extern int       shift=60;

int init()
  {
   focus=MathAbs(focus); if (focus<0.1) focus=0.1; if (focus>10) focus=10;//   (  )     
   for (int i=0; i<=256; i++){
	  double Hue=i; Hue=Hue/256;
	  color RGB_0=HSLtoRGB(Hue, Staturation_0, Lightness_0);
	  Hue=SpectralFilter(Hue, focus);
	  color RGB=HSLtoRGB(Hue, Staturation, Lightness);
	  string name_0=StringConcatenate("rainbow_dash(0) ", i);
	  string name=StringConcatenate("rainbow_dash ", i);
	  ObjectCreate(name_0, OBJ_TREND, 0, Time[i], Close[0]+(shift/2)*Point, Time[i], Close[0]+(shift/2+h)*Point);
	  ObjectCreate(name, OBJ_TREND, 0, Time[i], Close[0]-(shift/2)*Point, Time[i], Close[0]-(shift/2+h)*Point);
	  ObjectSet(name_0, OBJPROP_COLOR, RGB_0); ObjectSet(name, OBJPROP_COLOR, RGB);
	  ObjectSet(name_0, OBJPROP_STYLE, STYLE_SOLID); ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
	  ObjectSet(name_0, OBJPROP_WIDTH, 2); ObjectSet(name, OBJPROP_WIDTH, 2);
	  ObjectSet(name_0, OBJPROP_RAY, false); ObjectSet(name, OBJPROP_RAY, false);
   }
   return(0);
  }

int deinit()
  {
   for (int i=0; i<=256; i++){
      ObjectDelete(StringConcatenate("rainbow_dash(0) ", i));
      ObjectDelete(StringConcatenate("rainbow_dash ", i));
   }
   return(0);
  }

void start(){}

double Hue_To_RGB(double P,double Q,double Tc){
	if(Tc<0) Tc+=1.0;
	if(Tc>1.0) Tc-=1.0;
	if(Tc<1.0/6.0) return(P+(Q-P)*6.0*Tc);
	if(Tc<1.0/2.0) return(Q);
	if(Tc<2.0/3.0) return(P+(Q-P)*((2.0/3.0)-Tc)*6.0);
	return(P);
}

color HSLtoRGB(double aH,double aS,double aL){
	if(aS==0){
		double oR=aL*255;
		double oG=aL*255;
		double oB=aL*255;
	}else{
		double Q;
		if(aL<0.5) Q=aL*(1.0+aS); else Q=(aL+aS)-(aS*aL);
		double P=2.0*aL-Q;
		oR=255.0*Hue_To_RGB(P,Q,aH+(1.0/3.0));
		oG=255.0*Hue_To_RGB(P,Q,aH);
		oB=255.0*Hue_To_RGB(P,Q,aH-(1.0/3.0));
	}
	return(0x100*0x100*DoubleToInt(oB)+0x100*DoubleToInt(oG)+DoubleToInt(oR));
}

int DoubleToInt(double var){return(var);}

double SpectralFilter(double var, double focus){
   if (var<0.5) var=MathPow((MathPow(0.5,focus)-MathPow(MathAbs(var-0.5),focus)),1/focus);
   else var=1-MathPow((MathPow(0.5,focus)-MathPow(MathAbs(var-0.5),focus)),1/focus);
   return(var);
}